# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`wls_profile`](#wls_profile): wls_profile
* [`wls_profile::admin_server`](#wls_profileadmin_server): This is a highly customizable Puppet profile class to define a WebLogic Admin Server on your system.
* [`wls_profile::admin_server::pack_domain`](#wls_profileadmin_serverpack_domain): This class is the default implementation for packing a domain on the current server.
* [`wls_profile::admin_server::wls_cluster`](#wls_profileadmin_serverwls_cluster): This class is the default implementation for creating a WebLogic cluster on your system.
* [`wls_profile::admin_server::wls_datasources`](#wls_profileadmin_serverwls_datasources): This class is the default implementation for defining WebLogic datasources.
* [`wls_profile::admin_server::wls_jms`](#wls_profileadmin_serverwls_jms): This class is the default implementation for defining WebLogic JMS setup.
* [`wls_profile::admin_server::wls_servers`](#wls_profileadmin_serverwls_servers): This class makes sure all te required WebLogic machines and servers are defined on your system.
* [`wls_profile::admin_server::wls_users_and_groups`](#wls_profileadmin_serverwls_users_and_groups): This class is the default implementation for ensuring the correct WebLogic users and groups are available on the system.
* [`wls_profile::basic_domain`](#wls_profilebasic_domain): wls_profile::basic_domain  This is a highly customizable Puppet profile class to define a basic WebLogic (empty) domain on your system. At it
* [`wls_profile::basic_domain::wls_domain`](#wls_profilebasic_domainwls_domain): This class is the default implementation for defining a domain on your system.
* [`wls_profile::basic_domain::wls_startup`](#wls_profilebasic_domainwls_startup): This class is the default implementation for making sure WebLogic gets started after a system reboot.
* [`wls_profile::node`](#wls_profilenode): wls_profile::node  This is a highly customizable Puppet profile class to define a WebLogic node. At its core just adding:```contain wls_profi
* [`wls_profile::weblogic`](#wls_profileweblogic): wls_profile::weblogic  This is a highly customizable Puppet profile class to install the  WebLogic software and its requirements on your syst
* [`wls_profile::weblogic::em_license`](#wls_profileweblogicem_license): This class will deploy the Enterprise Modules license.
* [`wls_profile::weblogic::fmw_software`](#wls_profileweblogicfmw_software): This class is the default implementation for creating the required OS users and groups for the installation of WebLogic.
* [`wls_profile::weblogic::java_software`](#wls_profileweblogicjava_software): This class is the default implementation for making sure the Java software is correctly installed on your system.
* [`wls_profile::weblogic::ssh_setup`](#wls_profileweblogicssh_setup): This class is the default implementation for making sure the WebLogic account has ssh keys setup so it can passwordless copy files.
* [`wls_profile::weblogic::wls_opatch`](#wls_profileweblogicwls_opatch): This class is the default implementation for ensuring your WebLogic Opatch is up-to-date.
* [`wls_profile::weblogic::wls_patches`](#wls_profileweblogicwls_patches): This class is the default implementation for ensuring your WebLogic software has all the required patches installed.
* [`wls_profile::weblogic::wls_software`](#wls_profileweblogicwls_software): This class is the default implementation for installing the WebLogic software on your system.

### Defined types

* [`wls_profile::admin_server::managed_server`](#wls_profileadmin_servermanaged_server): This defined type is the default implementation for defining a managed server in your WebLogic domain.
* [`wls_profile::weblogic::private::start_managed_servers`](#wls_profileweblogicprivatestart_managed_servers)
* [`wls_profile::weblogic::private::stop_managed_servers`](#wls_profileweblogicprivatestop_managed_servers)

### Plans

* [`wls_profile::weblogic::apply_patches`](#wls_profileweblogicapply_patches): Apply the in hiera specified WebLogic patches to the specified target

## Classes

### <a name="wls_profile"></a>`wls_profile`

wls_profile

#### Parameters

The following parameters are available in the `wls_profile` class:

* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`cluster_name`](#cluster_name)
* [`domain_name`](#domain_name)
* [`domains_dir`](#domains_dir)
* [`download_dir`](#download_dir)
* [`java_full_version`](#java_full_version)
* [`java_version`](#java_version)
* [`jdk_home`](#jdk_home)
* [`log_dir`](#log_dir)
* [`middleware_home`](#middleware_home)
* [`nodemanager_address`](#nodemanager_address)
* [`nodemanager_port`](#nodemanager_port)
* [`oracle_base`](#oracle_base)
* [`os_group`](#os_group)
* [`os_user`](#os_user)
* [`servers`](#servers)
* [`source`](#source)
* [`temp_dir`](#temp_dir)
* [`weblogic_home`](#weblogic_home)
* [`weblogic_password`](#weblogic_password)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_version`](#weblogic_version)
* [`install_type`](#install_type)

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`



##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`



##### <a name="cluster_name"></a>`cluster_name`

Data type: `String[1]`



##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`



##### <a name="domains_dir"></a>`domains_dir`

Data type: `Stdlib::Absolutepath`



##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`



##### <a name="java_full_version"></a>`java_full_version`

Data type: `String[1]`



##### <a name="java_version"></a>`java_version`

Data type: `String[1]`



##### <a name="jdk_home"></a>`jdk_home`

Data type: `Stdlib::Absolutepath`



##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`



##### <a name="middleware_home"></a>`middleware_home`

Data type: `Stdlib::Absolutepath`



##### <a name="nodemanager_address"></a>`nodemanager_address`

Data type: `String[1]`



##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`



##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`



##### <a name="os_group"></a>`os_group`

Data type: `String[1]`



##### <a name="os_user"></a>`os_user`

Data type: `String[1]`



##### <a name="servers"></a>`servers`

Data type: `Hash`



##### <a name="source"></a>`source`

Data type: `String[1]`



##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`



##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`



##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`



##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`



##### <a name="weblogic_version"></a>`weblogic_version`

Data type: `Wls_install::Versions`



##### <a name="install_type"></a>`install_type`

Data type: `Enum[
    'standard',
    'forms',
    'ohs_standalone',
    'adf_restricted',
    'osb',
    'osb_soa',
    'osb_soa_bpm',
    'soa',
    'soa_bpm',
    'bam',
    'adf',
    'oim',
    'oud',
    'wc',
  'wc_wcc_bpm']`



Default value: `'standard'`

### <a name="wls_profileadmin_server"></a>`wls_profile::admin_server`

wls_profile::admin_server

At its core just adding:

```
contain wls_profile::admin_server
```

Is enough to get a WebLogic domain running on your system.

But sometimes you have specific uses cases that are not handled well by the standard classes. This profile class allows you to add your own code to the execution.

## Stages

Defining and starting a WebLogic Admin Server on your system goes through several stages(These are not puppet stages):

- [`basic_domain`](./basic_domain.html)   Install the WebLogic software and create a basic (empty) domain
- [`wls_servers`](./wls_servers.html)   Create the WebLogic machines, servers you want in your domain
- [`wls_cluster`](./wls_cluster.html)   Create the WebLogic cluster you want in your domain
- [`wls_datasources`](./wls_datasources)   Create the WebLogic datasources you want in your domain
- [`wls_jms`](./wls_jms.html)   Setup your JMS configuration for your domain
- [`wls_users_and_groups`](./wls_users_and_groups.html)    The WebLogic users and groups
- [`pack_domain`](./pack_domain.html)   Pack the domain for transportation to an other WebLogic server

All these stages have a default implementation. This implementation is suitable to get started with. These classed all have parameters you can customize through hiera values. The defaults are specified in the module's `data/default.yaml` file.

## before classes

But sometimes this is not enough, and you would like to add some extra definitions, you can, for example, add a Puppet class to be executed after the `wls_datasources` stage is done and before the `wls_jms` is done. You can do this by adding the next line to your yaml data:

```yaml
wls_profile::admin_server::before_wls_jms:   my_profile::my_extra_class
```

## after classes

You can do the same when you want to add code after one of the stage classes:

```yaml
wls_profile::admin_server::after_wls_users_and_groups:   my_profile::my_extra_class
```

## Skipping

Sometimes organizations use different modules and mechanisms to implement a feature, and you want to skip the class:

```yaml
wls_profile::admin_server::pack_domain:   skip
```

## Replacing

Or provide your own implementation:

```yaml
wls_profile::admin_server::wls_datasources:   my_profile::my_own_implementation
```

This mechanism can be used for all named stages and makes it easy to move from an easy setup with a running standard WebLogic Admin server to a fully customized setup using a lot of your own classes plugged in.

Look at the description of the stages and their properties.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server` class:

* [`basic_domain`](#basic_domain)
* [`wls_servers`](#wls_servers)
* [`wls_cluster`](#wls_cluster)
* [`wls_datasources`](#wls_datasources)
* [`wls_jms`](#wls_jms)
* [`wls_users_and_groups`](#wls_users_and_groups)
* [`pack_domain`](#pack_domain)
* [`before_basic_domain`](#before_basic_domain)
* [`before_wls_servers`](#before_wls_servers)
* [`before_wls_cluster`](#before_wls_cluster)
* [`before_wls_datasources`](#before_wls_datasources)
* [`before_wls_jms`](#before_wls_jms)
* [`before_wls_users_and_groups`](#before_wls_users_and_groups)
* [`before_pack_domain`](#before_pack_domain)
* [`after_basic_domain`](#after_basic_domain)
* [`after_wls_servers`](#after_wls_servers)
* [`after_wls_cluster`](#after_wls_cluster)
* [`after_wls_datasources`](#after_wls_datasources)
* [`after_wls_jms`](#after_wls_jms)
* [`after_wls_users_and_groups`](#after_wls_users_and_groups)
* [`after_pack_domain`](#after_pack_domain)

##### <a name="basic_domain"></a>`basic_domain`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `basic_domain`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::basic_domain:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::basic_domain:  skip
```

Default value: ``undef``

##### <a name="wls_servers"></a>`wls_servers`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_servers`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_servers:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_servers:  skip
```

Default value: ``undef``

##### <a name="wls_cluster"></a>`wls_cluster`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_cluster`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_cluster:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_cluster:  skip
```

Default value: ``undef``

##### <a name="wls_datasources"></a>`wls_datasources`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_datasources`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_datasources:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_datasources:  skip
```

Default value: ``undef``

##### <a name="wls_jms"></a>`wls_jms`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_jms`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_jms:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_jms:  skip
```

Default value: ``undef``

##### <a name="wls_users_and_groups"></a>`wls_users_and_groups`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_users_and_groups`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_users_and_groups:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::wls_users_and_groups:  skip
```

Default value: ``undef``

##### <a name="pack_domain"></a>`pack_domain`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `pack_domain`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::pack_domain:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::pack_domain:  skip
```

Default value: ``undef``

##### <a name="before_basic_domain"></a>`before_basic_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `basic_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_basic_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_servers"></a>`before_wls_servers`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_servers` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_wls_servers:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_cluster"></a>`before_wls_cluster`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_cluster` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_wls_cluster:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_datasources"></a>`before_wls_datasources`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_datasources` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_wls_datasources:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_jms"></a>`before_wls_jms`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_jms` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_wls_jms:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_users_and_groups"></a>`before_wls_users_and_groups`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_users` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_wls_users:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_pack_domain"></a>`before_pack_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `pack_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::before_pack_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_basic_domain"></a>`after_basic_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `basic_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::basic_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_servers"></a>`after_wls_servers`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_servers` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::after_wls_servers:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_cluster"></a>`after_wls_cluster`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_cluster` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::after_wls_cluster:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_datasources"></a>`after_wls_datasources`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_datasources` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::after_wls_datasources:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_jms"></a>`after_wls_jms`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_jms` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::after_wls_jms:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_users_and_groups"></a>`after_wls_users_and_groups`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_users_and_groups` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::after_wls_users_and_groups:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_pack_domain"></a>`after_pack_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `pack_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::admin_server::after_pack_domain:  my_module::my_class
```

Default value: ``undef``

### <a name="wls_profileadmin_serverpack_domain"></a>`wls_profile::admin_server::pack_domain`

wls_profile::admin_server::pack_domain

The packed domain can be used to create other WebLogic nodes in the same domain. When you are creating just a single node WebLogic server, you can skip this class.

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::admin_server](./admin_server.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::pack_domain` class:

* [`domain_name`](#domain_name)
* [`middleware_home`](#middleware_home)
* [`weblogic_home`](#weblogic_home)
* [`jdk_home`](#jdk_home)
* [`domains_dir`](#domains_dir)
* [`os_user`](#os_user)
* [`os_group`](#os_group)

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The name of the WebLogic domain.
This will be used both as the REAL WebLogic domain name, and also be used by Puppet as a designator for Puppet resources. (e.g. the name before the slash `my_domain/wls_queue1`).
The change the domain name, use the hiera key: `wls_profile::domain_name`. This will make sure the correct domain name gets used in all classes.
The default value is: `MYDOMAIN`

##### <a name="middleware_home"></a>`middleware_home`

Data type: `Stdlib::Absolutepath`

The Oracle middleware home directory.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::middleware_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12`

##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`

The directory used as WebLogic home
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12/wlserver`

##### <a name="jdk_home"></a>`jdk_home`

Data type: `Stdlib::Absolutepath`

The location where the JDK is installed.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::jdk_home` to change it to your requested value.
The default value is: `/usr/java/jdk1.8.0_152`

##### <a name="domains_dir"></a>`domains_dir`

Data type: `Stdlib::Absolutepath`

The top-level directory where the domain directories will reside in.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::domains_dir` to change it to your requested value.
The default value is:  `/opt/oracle/domains`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_group` to change it to your requested value.
Default value: `dba`

### <a name="wls_profileadmin_serverwls_cluster"></a>`wls_profile::admin_server::wls_cluster`

wls_profile::admin_server::wls_cluster

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::admin_server](./admin_server.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::wls_cluster` class:

* [`domain_name`](#domain_name)
* [`cluster_name`](#cluster_name)
* [`servers`](#servers)
* [`cluster_defaults`](#cluster_defaults)

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The name of the WebLogic domain.
This will be used both as the REAL WebLogic domain name, and also be used by Puppet as a designator for Puppet resources. (e.g. the name before the slash `my_domain/wls_queue1`).
The change the domain name, use the hiera key: `wls_profile::domain_name`. This will make sure the correct domain name gets used in all classes.
The default value is: `MYDOMAIN`

##### <a name="cluster_name"></a>`cluster_name`

Data type: `String[1]`

The name to use for the cluster.
The change the domain name, use the hiera key: `wls_profile::cluster_name`. This will make sure the correct domain name gets used in all classes.
Default value is: `main`

##### <a name="servers"></a>`servers`

Data type: `Hash`

A Hash of machine-servers defining all servers that need to be part of the cluster.
The default implementations reads these values from the hiera key `wls_profile::admin_server::wls_servers::servers`

Default value: `$wls_profile::servers`

##### <a name="cluster_defaults"></a>`cluster_defaults`

Data type: `Hash`

A Hash of default values used when creating a `wls_cluster` resource.
The default value is:
```yaml
wls_profile::admin_server::wls_cluster::cluster_defaults:
  messagingmode:  unicast
  migrationbasis: consensus
```

### <a name="wls_profileadmin_serverwls_datasources"></a>`wls_profile::admin_server::wls_datasources`

wls_profile::admin_server::wls_datasources

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::wls_datasources` class:

* [`list`](#list)

##### <a name="list"></a>`list`

Data type: `Hash`

A list of datasources to define.
The default value is: `{}`
This is a simple way to get started. It is easy to get started, but soon your hiera yaml become a nightmare. Our advice is when you need to let puppet manage your Oracle profiles, to override this class and add your own puppet implementation. This is much better maintainable and adds more consistency.

### <a name="wls_profileadmin_serverwls_jms"></a>`wls_profile::admin_server::wls_jms`

wls_profile::admin_server::wls_jms

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::wls_jms` class:

* [`module_list`](#module_list)
* [`queue_list`](#queue_list)
* [`topic_lis`](#topic_lis)
* [`topic_list`](#topic_list)

##### <a name="module_list"></a>`module_list`

Data type: `Hash`

A list of modules to define.
The default value is: `{}`
This is a simple way to get started. It is easy to get started, but soon your hiera yaml become a nightmare. Our advice is when you need to let puppet manage your Oracle profiles, to override this class and add your own puppet implementation. This is much better maintainable and adds more consistency.

##### <a name="queue_list"></a>`queue_list`

Data type: `Hash`

A list of JMS queues to define.
The default value is: `{}`
This is a simple way to get started. It is easy to get started, but soon your hiera yaml become a nightmare. Our advice is when you need to let puppet manage your Oracle profiles, to override this class and add your own puppet implementation. This is much better maintainable and adds more consistency.

##### <a name="topic_lis"></a>`topic_lis`

A list of JMS topics to define.
The default value is: `{}`
This is a simple way to get started. It is easy to get started, but soon your hiera yaml become a nightmare. Our advice is when you need to let puppet manage your Oracle profiles, to override this class and add your own puppet implementation. This is much better maintainable and adds more consistency.

##### <a name="topic_list"></a>`topic_list`

Data type: `Hash`



### <a name="wls_profileadmin_serverwls_servers"></a>`wls_profile::admin_server::wls_servers`

wls_profile::admin_server::wls_servers

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::wls_servers` class:

* [`domain_name`](#domain_name)
* [`servers`](#servers)
* [`server_defaults`](#server_defaults)
* [`machine_defaults`](#machine_defaults)

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The name of the WebLogic domain.
This will be used both as the REAL WebLogic domain name, and also be used by Puppet as a designator for Puppet resources. (e.g. the name before the slash `my_domain/wls_queue1`).
The change the domain name, use the hiera key: `wls_profile::domain_name`. This will make sure the correct domain name gets used in all classes.
The default value is: `MYDOMAIN`

##### <a name="servers"></a>`servers`

Data type: `Hash`



Default value: `$wls_profile::servers`

##### <a name="server_defaults"></a>`server_defaults`

Data type: `Hash`



##### <a name="machine_defaults"></a>`machine_defaults`

Data type: `Hash`



### <a name="wls_profileadmin_serverwls_users_and_groups"></a>`wls_profile::admin_server::wls_users_and_groups`

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::wls_users_and_groups` class:

* [`group_list`](#group_list)
* [`user_list`](#user_list)

##### <a name="group_list"></a>`group_list`

Data type: `Hash`

A list of WebLogic groups to define.
The default value is: `{}`
This is a simple way to get started. It is easy to get started, but soon your hiera yaml become a nightmare. Our advice is when you need to let puppet manage your Oracle profiles, to override this class and add your own puppet implementation. This is much better maintainable and adds more consistency.

##### <a name="user_list"></a>`user_list`

Data type: `Hash`

A list of WebLogic users to define.
The default value is: `{}`
This is a simple way to get started. It is easy to get started, but soon your hiera yaml become a nightmare. Our advice is when you need to let puppet manage your Oracle profiles, to override this class and add your own puppet implementation. This is much better maintainable and adds more consistency.

### <a name="wls_profilebasic_domain"></a>`wls_profile::basic_domain`

wls_profile::basic_domain

This is a highly customizable Puppet profile class to define a basic WebLogic (empty) domain on your system. At its core just adding:```contain wls_profile::basic_domain```Is enough to get an empty WebLogic domain running on your system. But sometimes you have specific uses cases that are not handled well by the standard classes. This profile class allows you to add your own code to the execution.## StagesDefining and starting an empty basic WebLogic domain on you system goes through several stages(These are not puppet stages):- [`weblogic`](./weblogic.html) Install and patch the WebLogic software- [`wls_domain`](./wls_domain.html)    Create an empty WebLogic domain- [`wls_startup`](./wls_startup.html)   Make sure the domain restarts after a system reboot.All these stages have a default implementation. This implementation is suitable to get off to an easy start. These classed all have parameters you can customize through hiera values. The defaults are specified in the module's `data/default.yaml` file. ## before classesBut sometimes this is not enough, and you would like to add some extra definitions, you can, for example, add a Puppet class to be executed after the `weblogic` stage is done and before the `wls_domain` is done. You can do this by adding the next line to your yaml data:```yamlwls_profile::basic_domain::before_wls_domain:   my_profile::my_extra_class```## after classesYou can do the same when you want to add code after one of the stage classes:```yamlwls_profile::basic_domain::after_wls_domain:   my_profile::my_extra_class```## SkippingSometimes organizations use different modules and mechanisms to implement a feature, and you want to skip the class:```yamlwls_profile::basic_domain::wls_startup:   skip```## ReplacingOr provide your own implementation:```yamlwls_profile::basic_domain::wls_domain:   my_profile::my_own_implementation```This mechanism can be used for all named stages and makes it easy to move from an easy setup with a running standard WebLogic installation to a fully customized setup using a lot of your own classes plugged in.Look at the description of the stages and their properties.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::basic_domain` class:

* [`weblogic`](#weblogic)
* [`wls_domain`](#wls_domain)
* [`wls_startup`](#wls_startup)
* [`before_weblogic`](#before_weblogic)
* [`before_wls_domain`](#before_wls_domain)
* [`before_wls_startup`](#before_wls_startup)
* [`after_weblogic`](#after_weblogic)
* [`after_wls_domain`](#after_wls_domain)
* [`after_wls_startup`](#after_wls_startup)

##### <a name="weblogic"></a>`weblogic`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `weblogic`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::weblogic:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::weblogic:  skip
```

Default value: ``undef``

##### <a name="wls_domain"></a>`wls_domain`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_domain`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::wls_domain:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::wls_domain:  skip
```

Default value: ``undef``

##### <a name="wls_startup"></a>`wls_startup`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_startup`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::wls_startup:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::wls_startup:  skip
```

Default value: ``undef``

##### <a name="before_weblogic"></a>`before_weblogic`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `weblogic` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::before_weblogic:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_domain"></a>`before_wls_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::before_wls_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_startup"></a>`before_wls_startup`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_startup` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::before_wls_startup:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_weblogic"></a>`after_weblogic`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `weblogic` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::after_weblogic:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_domain"></a>`after_wls_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::after_wls_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_startup"></a>`after_wls_startup`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_startup` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::basic_domain::after_wls_startup:  my_module::my_class
```

Default value: ``undef``

### <a name="wls_profilebasic_domainwls_domain"></a>`wls_profile::basic_domain::wls_domain`

wls_profile::basic_domain::wls_domain

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::basic_domain](./basic_domain.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::basic_domain::wls_domain` class:

* [`domain_name`](#domain_name)
* [`domain_alias`](#domain_alias)
* [`version`](#version)
* [`weblogic_home`](#weblogic_home)
* [`domains_dir`](#domains_dir)
* [`log_dir`](#log_dir)
* [`template_name`](#template_name)
* [`nodemanager_address`](#nodemanager_address)
* [`nodemanager_port`](#nodemanager_port)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`administration_port_enabled`](#administration_port_enabled)
* [`administration_port`](#administration_port)
* [`adminserver_ssl_port`](#adminserver_ssl_port)
* [`java_update_window`](#java_update_window)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`bam_enabled`](#bam_enabled)
* [`b2b_enabled`](#b2b_enabled)
* [`ess_enabled`](#ess_enabled)
* [`development_mode`](#development_mode)
* [`nodemanager_wait`](#nodemanager_wait)
* [`adminserver_settings`](#adminserver_settings)
* [`custom_identity`](#custom_identity)
* [`custom_identity_alias`](#custom_identity_alias)
* [`custom_identity_keystore_filename`](#custom_identity_keystore_filename)
* [`custom_trust`](#custom_trust)
* [`extra_properties`](#extra_properties)
* [`jdk_home`](#jdk_home)
* [`jsse_enabled`](#jsse_enabled)
* [`middleware_home`](#middleware_home)
* [`trust_keystore_file`](#trust_keystore_file)
* [`custom_identity_keystore_passphrase`](#custom_identity_keystore_passphrase)
* [`custom_identity_privatekey_passphrase`](#custom_identity_privatekey_passphrase)
* [`rcu_database_url`](#rcu_database_url)
* [`repository_database_url`](#repository_database_url)
* [`repository_password`](#repository_password)
* [`repository_prefix`](#repository_prefix)
* [`repository_sys_password`](#repository_sys_password)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The name of the WebLogic domain.
This will be used both as the REAL WebLogic domain name, and also be used by Puppet as a designator for Puppet resources. (e.g. the name before the slash `my_domain/wls_queue1`).
The change the domain name, use the hiera key: `wls_profile::domain_name`. This will make sure the correct domain name gets used in all classes.
The default value is: `MYDOMAIN`

##### <a name="domain_alias"></a>`domain_alias`

Data type: `String[1]`

The domain alias.
This is the name puppet uses to identify this domain. When you leave this parameter undefined, it will default to the current WebLogic domain name. When you specify the string 'default', Puppet will use this domain by default when you don't specify a resource for all of the `wls_config` resources.

Default value: `$domain_name`

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version of WebLogic you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::version` to change it to your requested value.
Valid values are:
  - `1036`
  - `1111`
  - `1112`
  - `1211`
  - `1212`
  - `1213`
  - `1221`
  - `12211`
  - `12212`
  - `12213`
  - `12214`
Default value: `12213`

Default value: `$wls_profile::weblogic_version`

##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`

The directory used as WebLogic home
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12/wlserver`

##### <a name="domains_dir"></a>`domains_dir`

Data type: `Stdlib::Absolutepath`

The top-level directory where the domain directories will reside in.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::domains_dir` to change it to your requested value.
The default value is:  `/opt/oracle/domains`

##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`

The directory used for log files.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::log_dir` to change it to your requested value.
Default value: `/opt/oracle/domains/log`

##### <a name="template_name"></a>`template_name`

Data type: `Enum[
    'standard',
    'forms',
    'ohs_standalone',
    'adf_restricted',
    'osb',
    'osb_soa',
    'osb_soa_bpm',
    'soa',
    'soa_bpm',
    'bam',
    'adf',
    'oim',
    'oud',
    'wc',
    'wc_wcc_bpm']`

The domain template to use when creating the domain.
The default value is `standard`.
Valid values are:
- `standard`
- `ohs_standalone`
- `adf_restricted`
- `osb`
- `osb_soa`
- `osb_soa_bpm`
- `soa`
- `soa_bpm`
- `bam`
- `adf`
- `oim`
- `oud`
- `wc`
- `wc_wcc_bpm`

##### <a name="nodemanager_address"></a>`nodemanager_address`

Data type: `String[1]`

The IP address the nodemanager will run and listen on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::wls_domain::log_dir` to change it to your requested value.
Default value: `::fqdn`

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager listens on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::nodemanager_port` to change it to your requested value.
Default value: `5556`

Default value: `$wls_profile::nodemanager_port`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address the admin server process will run and listen on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::adminserver_address` to change it to your requested value.
The default value is: The fact `fqdn`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server process will run and listen on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::adminserver_port` to change it to your requested value.
The default value is:  `7001`

Default value: `$wls_profile::adminserver_port`

##### <a name="administration_port_enabled"></a>`administration_port_enabled`

Data type: `Boolean`

Specifies whether the domain-wide administration port should be enabled for this WebLogic Server domain.
Because the administration port uses SSL, enabling the administration port requires that SSL must be configured for all servers in the domain.
The domain-wide administration port enables you to start a WebLogic Server instance in STANDBY state. It also allows you to separate administration traffic from application traffic in your domain. Because all servers in the domain must enable or disable the administration port at once, you configure the default administration port settings at the domain level.
If you enable the administration port:
The administration port accepts only connections that specify administrator credentials.
Connections that specify administrator credentials can use only the administration port.
The command that starts managed servers must specify a secure protocol and the administration port: -Dweblogic.management.server=https://admin_server:administration_port

##### <a name="administration_port"></a>`administration_port`

Data type: `Optional[Integer]`

The common secure administration port for this WebLogic Server domain.
(Requires you to enable the administration port.)

##### <a name="adminserver_ssl_port"></a>`adminserver_ssl_port`

Data type: `Optional[Integer]`

SSL port to use for the Admin server.

##### <a name="java_update_window"></a>`java_update_window`

Data type: `Optional[String[1]]`

The time frame in which any required java updates will be applied to your domain by Puppet.
Puppet will apply any detected java updates immediately if the value is `undef`, which is the default.

Default value: ``undef``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_group` to change it to your requested value.
Default value: `dba`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The WebLogic user account to bear all administration rights.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_user` to change it to your requested value.
Default value: `weblogic`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password for the WebLogic account.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_password` to change it to your requested value.
Default value: `Welcome01`

##### <a name="bam_enabled"></a>`bam_enabled`

Data type: `Boolean`

A boolean value specifying if you want to enable bam.
Default value: `false`

##### <a name="b2b_enabled"></a>`b2b_enabled`

Data type: `Boolean`

A boolean value specifying if you want to enable b2b.
Default value: `false`

##### <a name="ess_enabled"></a>`ess_enabled`

Data type: `Boolean`

A boolean value specifying if you want to enable ess.
Default value: `false`

##### <a name="development_mode"></a>`development_mode`

Data type: `Boolean`

A boolean value specifying if you want to enable development mode.
Default value: `false`

##### <a name="nodemanager_wait"></a>`nodemanager_wait`

Data type: `Integer`

The time in seconds Puppet waits for the nodemanager to start before declaring an error.
Default value: `20`

##### <a name="adminserver_settings"></a>`adminserver_settings`

Data type: `Hash`

A Hash containing settings (of type `wls_server`) to define for the Admin server.
The default value is: `{}`

##### <a name="custom_identity"></a>`custom_identity`

Data type: `Boolean`



##### <a name="custom_identity_alias"></a>`custom_identity_alias`

Data type: `Optional[String[1]]`



##### <a name="custom_identity_keystore_filename"></a>`custom_identity_keystore_filename`

Data type: `Optional[String[1]]`



##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`



##### <a name="extra_properties"></a>`extra_properties`

Data type: `Array`



##### <a name="jdk_home"></a>`jdk_home`

Data type: `Stdlib::Absolutepath`



##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`



##### <a name="middleware_home"></a>`middleware_home`

Data type: `Stdlib::Absolutepath`



##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`



##### <a name="custom_identity_keystore_passphrase"></a>`custom_identity_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`



Default value: ``undef``

##### <a name="custom_identity_privatekey_passphrase"></a>`custom_identity_privatekey_passphrase`

Data type: `Optional[Easy_type::Password]`



Default value: ``undef``

##### <a name="rcu_database_url"></a>`rcu_database_url`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="repository_database_url"></a>`repository_database_url`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="repository_password"></a>`repository_password`

Data type: `Optional[Easy_type::Password]`



Default value: ``undef``

##### <a name="repository_prefix"></a>`repository_prefix`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="repository_sys_password"></a>`repository_sys_password`

Data type: `Optional[Easy_type::Password]`



Default value: ``undef``

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`



Default value: ``undef``

### <a name="wls_profilebasic_domainwls_startup"></a>`wls_profile::basic_domain::wls_startup`

wls_profile::basic_domain::wls_startup

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::basic_domain::wls_startup` class:

* [`domain_name`](#domain_name)
* [`version`](#version)
* [`weblogic_home`](#weblogic_home)
* [`domains_dir`](#domains_dir)
* [`log_dir`](#log_dir)
* [`os_user`](#os_user)
* [`custom_trust`](#custom_trust)
* [`jsse_enabled`](#jsse_enabled)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The name of the WebLogic domain.
This will be used both as the REAL WebLogic domain name, and also be used by Puppet as a designator for Puppet resources. (e.g. the name before the slash `my_domain/wls_queue1`).
The change the domain name, use the hiera key: `wls_profile::domain_name`. This will make sure the correct domain name gets used in all classes.
The default value is: `MYDOMAIN`

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version of WebLogic you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::version` to change it to your requested value.
Valid values are:
  - `1036`
  - `1111`
  - `1112`
  - `1211`
  - `1212`
  - `1213`
  - `1221`
  - `12211`
  - `12212`
  - `12213`
  - `12214`
Default value: `12213`

Default value: `$wls_profile::weblogic_version`

##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`

The directory used as WebLogic home
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12/wlserver`

##### <a name="domains_dir"></a>`domains_dir`

Data type: `Stdlib::Absolutepath`

The top-level directory where the domain directories will reside in.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::domains_dir` to change it to your requested value.
The default value is:  `/opt/oracle/domains`

##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`

The directory used for log files.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::log_dir` to change it to your requested value.
Default value: `/opt/oracle/domains/log`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`



##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`



##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`



##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`



Default value: `lookup('wls_profile::basic_domain::wls_domain::trust_keystore_passphrase', { 'default_value' => undef })`

### <a name="wls_profilenode"></a>`wls_profile::node`

wls_profile::node

This is a highly customizable Puppet profile class to define a WebLogic node. At its core just adding:```contain wls_profile::node```Is enough to get the WebLogic software nstalled, fetch the domain definition from the Admin Server and start the node manager.But sometimes, you have specific uses cases that are not handled well by the standard classes. This profile class allows you to add your own code to the execution.## StagesDefining and starting a WebLogic Admin Server on your system goes through several stages(These are not puppet stages):- [`weblogic`](./weblogic.html)     Setup the OS and install the WebLogic software- [`copy_domain`](./copy_domain.html)   Copy the packed domain from the AdminServer and start the Nodemanager- [`wls_startup`](./wls_startup.html)   Ensure WebLogic gets started after a reboot.All these stages have a default implementation. This implementation is suitable to get started with. These classed all have parameters you can customize through hiera values. The defaults are specified in the module's `data/default.yaml` file. ## before classesBut sometimes this is not enough, and you would like to add some extra definitions, you can, for example, add a Puppet class to be executed after the `weblogic` stage is done and before the `copy_domain` is done. You can do this by adding the next line to your yaml data:```yamlwls_profile::node::before_copy_domain:   my_profile::my_extra_class```## after classesYou can do the same when you want to add code after one of the stage classes:```yamlwls_profile::node::wls_startup:   my_profile::my_extra_class```## SkippingSometimes organizations use different modules and mechanisms to implement a feature, and you want to skip the class:```yamlwls_profile::node::pack_domain:   skip```## ReplacingOr provide your own implementation:```yamlwls_profile::admin_server::copy_domain:   my_profile::my_own_implementation```This mechanism can be used for all named stages and makes it easy to move from an easy setup with a running standard WebLogic node server to a fully customized setup using a lot of your own classes plugged in.Look at the description of the stages and their properties.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::node` class:

* [`weblogic`](#weblogic)
* [`copy_domain`](#copy_domain)
* [`wls_startup`](#wls_startup)
* [`before_weblogic`](#before_weblogic)
* [`before_copy_domain`](#before_copy_domain)
* [`before_wls_startup`](#before_wls_startup)
* [`after_weblogic`](#after_weblogic)
* [`after_copy_domain`](#after_copy_domain)
* [`after_wls_startup`](#after_wls_startup)

##### <a name="weblogic"></a>`weblogic`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `weblogic`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::weblogic:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::weblogic:  skip
```

Default value: ``undef``

##### <a name="copy_domain"></a>`copy_domain`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `copy_domain`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::copy_domain:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::copy_domain:  skip
```

Default value: ``undef``

##### <a name="wls_startup"></a>`wls_startup`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_startup`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::wls_startup:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::wls_startup:  skip
```

Default value: ``undef``

##### <a name="before_weblogic"></a>`before_weblogic`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `weblogic` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::before_weblogic:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_copy_domain"></a>`before_copy_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `copy_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::before_copy_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_startup"></a>`before_wls_startup`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_startup` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::before_wls_startup:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_weblogic"></a>`after_weblogic`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `weblogic` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::after_weblogic:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_copy_domain"></a>`after_copy_domain`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `copy_domain` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::after_copy_domain:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_startup"></a>`after_wls_startup`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_startup` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::node::after_wls_startup:  my_module::my_class
```

Default value: ``undef``

### <a name="wls_profileweblogic"></a>`wls_profile::weblogic`

wls_profile::weblogic

This is a highly customizable Puppet profile class to install the  WebLogic software and its requirements on your system. At its core, just adding:```contain wls_profile::weblogic```is enough to get the WebLogic software installed on your system. But sometimes, you have specific uses cases that are not handled well by the standard classes. This profile class allows you to add your own code to the execution.## StagesDefining and starting a WebLogic Admin Server on your system goes through several stages(These are not puppet stages):- [`sysctl`](/docs/wls_profile/sysctl.html)            Set required sysctl parameters- [`limits`](/docs/wls_profile/limits.html)            Set OS security limits- [`packages`](/docs/wls_profile/packages.html)          Install required packages- [`groups_and_users`](/docs/wls_profile/groups_and_users.html)  Create required OS users and groups- [`ssh_setup`](/docs/wls_profile/ssh_setup.html)         Setup SSH for accounts- [`firewall`](/docs/wls_profile/firewall.html)          Setup the firewall- [`java_software`](/docs/wls_profile/java_software.html)     Install the java software- [`wls_software`](/docs/wls_profile/wls_software.html)      Install the WebLogic software- [`wls_patches`](/docs/wls_profile/wls_patches.html)       Install the WebLogic patchesAll these stages have a default implementation. This implementation is suitable to get started with. These classed all have parameters you can customize through hiera values. The defaults are specified in the module's `data/default.yaml` file. ## before classesBut sometimes this is not enough, and you would like to add some extra definitions, you can, for example, add a Puppet class to be executed after the `packages` stage is done and before the `groups_and_users` is done. You can do this by adding the following line to your yaml data:```yamlwls_profile::weblogic::groups_and_users:   my_profile::my_extra_class```## after classesYou can do the same when you want to add code after one of the stage classes:```yamlwls_profile::weblogic::firewall:   my_profile::my_extra_class```## SkippingSometimes organizations use different modules and mechanisms to implement a feature, and you want to skip the class:```yamlwls_profile::weblogic::java_software:   skip```## ReplacingOr provide your own implementation:```yamlwls_profile::weblogic::wls_datasources:   my_profile::my_own_implementation```This mechanism can be used for all named stages and makes it easy to move from an easy setup with a running standard WebLogic software installation to a fully customized setup using a lot of your own classes plugged in.Look at the description of the stages and their properties.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic` class:

* [`sysctl`](#sysctl)
* [`limits`](#limits)
* [`packages`](#packages)
* [`groups_and_users`](#groups_and_users)
* [`ssh_setup`](#ssh_setup)
* [`firewall`](#firewall)
* [`java_software`](#java_software)
* [`wls_software`](#wls_software)
* [`wls_patches`](#wls_patches)
* [`before_sysctl`](#before_sysctl)
* [`before_limits`](#before_limits)
* [`before_packages`](#before_packages)
* [`before_groups_and_users`](#before_groups_and_users)
* [`before_ssh_setup`](#before_ssh_setup)
* [`before_firewall`](#before_firewall)
* [`before_java_software`](#before_java_software)
* [`before_wls_software`](#before_wls_software)
* [`before_wls_patches`](#before_wls_patches)
* [`after_sysctl`](#after_sysctl)
* [`after_limits`](#after_limits)
* [`after_packages`](#after_packages)
* [`after_groups_and_users`](#after_groups_and_users)
* [`after_ssh_setup`](#after_ssh_setup)
* [`after_firewall`](#after_firewall)
* [`after_java_software`](#after_java_software)
* [`after_wls_software`](#after_wls_software)
* [`after_wls_patches`](#after_wls_patches)
* [`after_em_license`](#after_em_license)
* [`after_fmw_software`](#after_fmw_software)
* [`after_wls_opatch`](#after_wls_opatch)
* [`before_em_license`](#before_em_license)
* [`before_fmw_software`](#before_fmw_software)
* [`before_wls_opatch`](#before_wls_opatch)
* [`em_license`](#em_license)
* [`fmw_software`](#fmw_software)
* [`wls_opatch`](#wls_opatch)

##### <a name="sysctl"></a>`sysctl`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `sysctl`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::sysctl:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::sysctl:  skip
```

Default value: ``undef``

##### <a name="limits"></a>`limits`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `limits`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::limits:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::limits:  skip
```

Default value: ``undef``

##### <a name="packages"></a>`packages`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `packages`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::packages:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::packages:  skip
```

Default value: ``undef``

##### <a name="groups_and_users"></a>`groups_and_users`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `groups_and_users`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::groups_and_users:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::groups_and_users:  skip
```

Default value: ``undef``

##### <a name="ssh_setup"></a>`ssh_setup`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `ssh_setup`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::ssh_setup:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::ssh_setup:  skip
```

Default value: ``undef``

##### <a name="firewall"></a>`firewall`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `firewall`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::firewall:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::firewall:  skip
```

Default value: ``undef``

##### <a name="java_software"></a>`java_software`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `java_software`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::java_software:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::java_software:  skip
```

Default value: ``undef``

##### <a name="wls_software"></a>`wls_software`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_software`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::wls_software:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::wls_software:  skip
```

Default value: ``undef``

##### <a name="wls_patches"></a>`wls_patches`

Data type: `Optional[String]`

Use this value if you want to skip or use your own class for stage `wls_patches`.
## Use your own class
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::wls_patches:  my_module::my_class
```
## Skip
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::wls_patches:  skip
```

Default value: ``undef``

##### <a name="before_sysctl"></a>`before_sysctl`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `sysctl` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_sysctl:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_limits"></a>`before_limits`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `limits` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_limits:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_packages"></a>`before_packages`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `packages` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_packages:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_groups_and_users"></a>`before_groups_and_users`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `groups_and_users` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_groups_and_users:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_ssh_setup"></a>`before_ssh_setup`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `ssh_setup` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_ssh_setup:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_firewall"></a>`before_firewall`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `firewall` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_firewall:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_java_software"></a>`before_java_software`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `java_software` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_java_software:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_software"></a>`before_wls_software`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_software` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_wls_software:  my_module::my_class
```

Default value: ``undef``

##### <a name="before_wls_patches"></a>`before_wls_patches`

Data type: `Optional[String]`

The name of the class you want to execute directly **before** the `wls_patches` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::before_wls_patches:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_sysctl"></a>`after_sysctl`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `sysctl` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_sysctl:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_limits"></a>`after_limits`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `limits` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_limits:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_packages"></a>`after_packages`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `packages` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_packages:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_groups_and_users"></a>`after_groups_and_users`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `groups_and_usesr` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_groups_and_usesr:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_ssh_setup"></a>`after_ssh_setup`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `ssh_setup` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_ssh_setup:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_firewall"></a>`after_firewall`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `firewall` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_firewall:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_java_software"></a>`after_java_software`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `java_software` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_java_software:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_software"></a>`after_wls_software`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_software` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_wls_software:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_wls_patches"></a>`after_wls_patches`

Data type: `Optional[String]`

The name of the class you want to execute directly **after** the `wls_patches` class.
You can use hiera to set this value. Here is an example:
```yaml
wls_profile::weblogic::after_wls_patches:  my_module::my_class
```

Default value: ``undef``

##### <a name="after_em_license"></a>`after_em_license`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="after_fmw_software"></a>`after_fmw_software`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="after_wls_opatch"></a>`after_wls_opatch`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="before_em_license"></a>`before_em_license`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="before_fmw_software"></a>`before_fmw_software`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="before_wls_opatch"></a>`before_wls_opatch`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="em_license"></a>`em_license`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="fmw_software"></a>`fmw_software`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="wls_opatch"></a>`wls_opatch`

Data type: `Optional[String]`



Default value: ``undef``

### <a name="wls_profileweblogicem_license"></a>`wls_profile::weblogic::em_license`

This class will deploy the Enterprise Modules license.

### <a name="wls_profileweblogicfmw_software"></a>`wls_profile::weblogic::fmw_software`

wls_profile::weblogic::fmw_software

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::fmw_software` class:

* [`file_name`](#file_name)
* [`oracle_base`](#oracle_base)
* [`middleware_home`](#middleware_home)
* [`weblogic_home`](#weblogic_home)
* [`jdk_home`](#jdk_home)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`source`](#source)
* [`version`](#version)

##### <a name="file_name"></a>`file_name`

Data type: `Array[String[1]]`



##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

The directory used as the base for all Oracle weblogic files.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::oracle_base` to change it to your requested value.
Default value: `/opt/oracle`

##### <a name="middleware_home"></a>`middleware_home`

Data type: `Stdlib::Absolutepath`

The Oracle middleware home directory.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::middleware_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12`

##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`

The directory used as WebLogic home
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12/wlserver`

##### <a name="jdk_home"></a>`jdk_home`

Data type: `Stdlib::Absolutepath`

The location where the JDK is installed.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::jdk_home` to change it to your requested value.
The default value is: `/usr/java/jdk1.8.0_152`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_group` to change it to your requested value.
Default value: `dba`

##### <a name="source"></a>`source`

Data type: `String[1]`

The location where the classes can find the software.
You can specify a local directory, a Puppet url or an http url.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::source` to change it to your requested value.
The default is : `puppet:///modules/software/`

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version of WebLogic you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::version` to change it to your requested value.
Valid values are:
  - `1036`
  - `1111`
  - `1112`
  - `1211`
  - `1212`
  - `1213`
  - `1221`
  - `12211`
  - `12212`
  - `12213`
  - `12214`
Default value: `12213`

Default value: `$wls_profile::weblogic_version`

### <a name="wls_profileweblogicjava_software"></a>`wls_profile::weblogic::java_software`

wls_profile::weblogic::java_software

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::java_software` class:

* [`version`](#version)
* [`full_version`](#full_version)
* [`cryptography_extension_file`](#cryptography_extension_file)
* [`source`](#source)
* [`urandom_fix`](#urandom_fix)
* [`rsa_key_size_fix`](#rsa_key_size_fix)
* [`x64`](#x64)
* [`alternatives_priority`](#alternatives_priority)

##### <a name="version"></a>`version`

Data type: `String[1]`

The version of java you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::java_version` to change it to your requested value.
Default value: `8u152`

##### <a name="full_version"></a>`full_version`

Data type: `String[1]`

The full version of java you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::java_full_version` to change it to your requested value.
Default value: `jdk1.8.0_152`

##### <a name="cryptography_extension_file"></a>`cryptography_extension_file`

Data type: `Optional[String[1]]`

Cryptographic extension file to use.
Default value: `jce_policy-8.zip`

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `String[1]`

The location where the classes can find the software.
You can specify a local directory, a Puppet url or an http url.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::source` to change it to your requested value.
The default is : `puppet:///modules/software/`

##### <a name="urandom_fix"></a>`urandom_fix`

Data type: `Optional[Boolean]`

Enable the urandom fix.
This parameter is deprecated and will be removed in a next version.
Default value: `true`

##### <a name="rsa_key_size_fix"></a>`rsa_key_size_fix`

Data type: `Optional[Boolean]`

Enable the RSA keysize fix.
Default value: `true`

##### <a name="x64"></a>`x64`

Data type: `Boolean`

Install x64 version of java.
Default value: `true`

##### <a name="alternatives_priority"></a>`alternatives_priority`

Data type: `Optional[Integer]`

alternatives priority for jdk.
Default value is: `18001`

### <a name="wls_profileweblogicssh_setup"></a>`wls_profile::weblogic::ssh_setup`

wls_profile::weblogic::ssh_setup

This is required when copying the packed domain from an admin server to a WebLogic node. If you are building singles node WebLogic configurations, you can skip this class.

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::admin_server](./admin_server.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::ssh_setup` class:

* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`private_key`](#private_key)
* [`public_key`](#public_key)

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_group` to change it to your requested value.
Default value: `dba`

##### <a name="private_key"></a>`private_key`

Data type: `String[1]`

The private key to create for the `os_user`  account.
The defaults contain a valid pair. It is recommended to specify your own values.

##### <a name="public_key"></a>`public_key`

Data type: `String[1]`

The public key to create for the `os_user`  account.
The defaults contain a valid pair. It is recommended to specify your own values.

### <a name="wls_profileweblogicwls_opatch"></a>`wls_profile::weblogic::wls_opatch`

wls_profile::weblogic::wls_opatch

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::wls_opatch` class:

* [`list`](#list)

##### <a name="list"></a>`list`

Data type: `Hash`

A Hash describing the WebLogic opatchupgrade you want be installed.
Default value is: `{}`

### <a name="wls_profileweblogicwls_patches"></a>`wls_profile::weblogic::wls_patches`

wls_profile::weblogic::wls_patches

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

The easiest and best way to specify your patches is to specify a `level`. An example of a patch level is `JAN2021RU`, meaning the JAN 2021 patch level update.

You can also add additional 'one-off's'. Use the `list` property to add these.

When you don't specify a patch windows, Puppet will never patch a running domain. It will however provide your installations with the specified patch level at the initial run or when the WebLogic domain is not running at the start of the Puppet run.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::wls_patches` class:

* [`level`](#level)
* [`version`](#version)
* [`middleware_home`](#middleware_home)
* [`orainst_dir`](#orainst_dir)
* [`jdk_home`](#jdk_home)
* [`os_user`](#os_user)
* [`list`](#list)
* [`domains_dir`](#domains_dir)
* [`weblogic_home`](#weblogic_home)
* [`os_group`](#os_group)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`adminserver_port`](#adminserver_port)
* [`nodemanager_port`](#nodemanager_port)
* [`wait_for_nodemanager`](#wait_for_nodemanager)
* [`nodemanager_address`](#nodemanager_address)
* [`adminserver_address`](#adminserver_address)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`patch_window`](#patch_window)
* [`logoutput`](#logoutput)
* [`patch_levels`](#patch_levels)

##### <a name="level"></a>`level`

Data type: `String[1]`

The specified patch level.
The default value is 'NONE'.

##### <a name="version"></a>`version`

Data type: `Integer`

The version of WebLogic you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::version` to change it to your requested value.
Valid values are:
  - `1036`
  - `1111`
  - `1112`
  - `1211`
  - `1212`
  - `1213`
  - `1221`
  - `12211`
  - `12212`
  - `12213`
  - `12214`
Default value: `12213`

##### <a name="middleware_home"></a>`middleware_home`

Data type: `String[1]`

The Oracle middleware home directory.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::middleware_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12`

##### <a name="orainst_dir"></a>`orainst_dir`

Data type: `String[1]`

The directory where the orainst file is located.

##### <a name="jdk_home"></a>`jdk_home`

Data type: `String[1]`

The location where the JDK is installed.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::jdk_home` to change it to your requested value.
The default value is: `/usr/java/jdk1.8.0_152`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="list"></a>`list`

Data type: `Hash`

A Hash describing the WebLogic patches you want be installed.
Default value is: `{}`

##### <a name="domains_dir"></a>`domains_dir`

Data type: `Stdlib::Absolutepath`

The top-level directory where the domain directories will reside in.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::domains_dir` to change it to your requested value.
The default value is:  `/opt/oracle/domains`

##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`

The directory used as WebLogic home
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12/wlserver`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_group` to change it to your requested value.
Default value: `dba`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The WebLogic user account to bear all administration rights.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_user` to change it to your requested value.
Default value: `weblogic`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password for the WebLogic account.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::weblogic_password` to change it to your requested value.
Default value: `Welcome01`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server process will run and listen on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::adminserver_port` to change it to your requested value.
The default value is:  `7001`

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager listens on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::nodemanager_port` to change it to your requested value.
Default value: `5556`

##### <a name="wait_for_nodemanager"></a>`wait_for_nodemanager`

Data type: `Integer`

The time in seconds we wait for the nodemanager to be started in the restart phase of the patching.

##### <a name="nodemanager_address"></a>`nodemanager_address`

Data type: `String[1]`

The IP address the nodemanager will run and listen on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::wls_domain::log_dir` to change it to your requested value.
Default value: `::fqdn`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address the admin server process will run and listen on.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::adminserver_address` to change it to your requested value.
The default value is: The fact `fqdn`

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specification of the trust keystore.

##### <a name="patch_window"></a>`patch_window`

Data type: `Optional[String[1]]`

The service window in which any patching will be executed.

Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`

log the outputs of Puppet exec and wls_exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

##### <a name="patch_levels"></a>`patch_levels`

Data type: `Hash`



### <a name="wls_profileweblogicwls_software"></a>`wls_profile::weblogic::wls_software`

wls_profile::weblogic::wls_software

Using hiera, you can customize some of the aspects of this process.

When these customizations aren't enough, you can replace the class with your own class. See [wls_profile::weblogic](./weblogic.html) for an explanation on how to do this.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::wls_software` class:

* [`version`](#version)
* [`file_name`](#file_name)
* [`oracle_base`](#oracle_base)
* [`middleware_home`](#middleware_home)
* [`jdk_home`](#jdk_home)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`source`](#source)
* [`fmw_infra`](#fmw_infra)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version of WebLogic you want to use.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::version` to change it to your requested value.
Valid values are:
  - `1036`
  - `1111`
  - `1112`
  - `1211`
  - `1212`
  - `1213`
  - `1221`
  - `12211`
  - `12212`
  - `12213`
  - `12214`
Default value: `12213`

Default value: `$wls_profile::weblogic_version`

##### <a name="file_name"></a>`file_name`

Data type: `String[1]`

The file name containing the Fusion middleware software to install.
This file is fetched from the location specified by the property `source`.

##### <a name="oracle_base"></a>`oracle_base`

Data type: `Stdlib::Absolutepath`

The directory used as the base for all Oracle weblogic files.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::oracle_base` to change it to your requested value.
Default value: `/opt/oracle`

##### <a name="middleware_home"></a>`middleware_home`

Data type: `Stdlib::Absolutepath`

The Oracle middleware home directory.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::middleware_home` to change it to your requested value.
Default value: `/opt/oracle/middleware12`

##### <a name="jdk_home"></a>`jdk_home`

Data type: `Stdlib::Absolutepath`

The location where the JDK is installed.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::jdk_home` to change it to your requested value.
The default value is: `/usr/java/jdk1.8.0_152`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_user` to change it to your requested value.
Default value: `oracle`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group to use for WebLogic.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::basic_domain::os_group` to change it to your requested value.
Default value: `dba`

##### <a name="source"></a>`source`

Data type: `String[1]`

The location where the classes can find the software.
You can specify a local directory, a Puppet url or an http url.
This value is used in multiple places. To make sure in all classed the correct value is used, use the hiera key `wls_profile::source` to change it to your requested value.
The default is : `puppet:///modules/software/`

##### <a name="fmw_infra"></a>`fmw_infra`

Data type: `Boolean`

Boolean specifying if you want WebLogic Fusion Middleware Infra installed.
Default value: `false`

## Defined types

### <a name="wls_profileadmin_servermanaged_server"></a>`wls_profile::admin_server::managed_server`

wls_profile::admin_server::managed_server

It is called once for every machine server combination you passed to `wls_profile::admin_server::wls_servers`.

Using hiera, you can customize some of the aspects of this process.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_profile::admin_server::managed_server` defined type:

* [`machine_name`](#machine_name)
* [`listenaddress`](#listenaddress)
* [`domain_name`](#domain_name)
* [`server_arguments`](#server_arguments)
* [`server_defaults`](#server_defaults)
* [`machine_defaults`](#machine_defaults)
* [`log_dir`](#log_dir)

##### <a name="machine_name"></a>`machine_name`

Data type: `String[1]`

The machine name to create for this managed server

##### <a name="listenaddress"></a>`listenaddress`

Data type: `String[1]`

The listen address for the managed server

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The name of the WebLogic domain.
This will be used both as the REAL WebLogic domain name, and also be used by Puppet as a designator for Puppet resources. (e.g. the name before the slash `my_domain/wls_queue1`).
The change the domain name, use the hiera key: `wls_profile::domain_name`. This will make sure the correct domain name gets used in all classes.
The default value is: `MYDOMAIN`

##### <a name="server_arguments"></a>`server_arguments`

Data type: `Array`

An Array containing the server startup arguments.
Default value is : `[]`

##### <a name="server_defaults"></a>`server_defaults`

Data type: `Hash`

a Hash describing the defauls to use when creating WebLogic servers.
Default value : `{}`

##### <a name="machine_defaults"></a>`machine_defaults`

Data type: `Hash`

a Hash describing the defauls to use when creating WebLogic machines.
Default value : `{}`

##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`



Default value: `lookup('wls_profile::log_dir')`

### <a name="wls_profileweblogicprivatestart_managed_servers"></a>`wls_profile::weblogic::private::start_managed_servers`

The wls_profile::weblogic::private::start_managed_servers class.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::private::start_managed_servers` defined type:

* [`schedule_name`](#schedule_name)
* [`domains_dir`](#domains_dir)
* [`weblogic_home`](#weblogic_home)
* [`middleware_home`](#middleware_home)
* [`jdk_home`](#jdk_home)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`adminserver_port`](#adminserver_port)
* [`nodemanager_port`](#nodemanager_port)
* [`adminserver_address`](#adminserver_address)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`wait_for_nodemanager`](#wait_for_nodemanager)
* [`trust_keystore_file`](#trust_keystore_file)
* [`logoutput`](#logoutput)

##### <a name="schedule_name"></a>`schedule_name`

Data type: `String[1]`



##### <a name="domains_dir"></a>`domains_dir`

Data type: `Stdlib::Absolutepath`



##### <a name="weblogic_home"></a>`weblogic_home`

Data type: `Stdlib::Absolutepath`



##### <a name="middleware_home"></a>`middleware_home`

Data type: `Stdlib::Absolutepath`



##### <a name="jdk_home"></a>`jdk_home`

Data type: `Stdlib::Absolutepath`



##### <a name="os_user"></a>`os_user`

Data type: `String[1]`



##### <a name="os_group"></a>`os_group`

Data type: `String[1]`



##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`



##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`



##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`



##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`



##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`



##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`



##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`



##### <a name="wait_for_nodemanager"></a>`wait_for_nodemanager`

Data type: `Integer`



##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`



Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

### <a name="wls_profileweblogicprivatestop_managed_servers"></a>`wls_profile::weblogic::private::stop_managed_servers`

The wls_profile::weblogic::private::stop_managed_servers class.

#### Parameters

The following parameters are available in the `wls_profile::weblogic::private::stop_managed_servers` defined type:

* [`schedule_name`](#schedule_name)
* [`logoutput`](#logoutput)

##### <a name="schedule_name"></a>`schedule_name`

Data type: `String[1]`



##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Boolean,Enum['on_failure']]`



Default value: `lookup( { name => 'logoutput', default_value => 'on_failure' })`

## Plans

### <a name="wls_profileweblogicapply_patches"></a>`wls_profile::weblogic::apply_patches`

This bolt plan applies the patches specified in the hieradata,
to the node it is running on. Because the service window is set to
ALWAYS (virtualy that is), the patching will start immediately. If the
WebLogic domain is running, it will be stopped before the patches
are applied and started after the patches are applied. It will only
restart managed servers that were running before the patching started.#

See the file "LICENSE" for the full license governing this code.

#### Examples

##### 

```puppet

bolt plan run wls_profile::weblogic::apply_patches targets=myserver1,myserver2
```

#### Parameters

The following parameters are available in the `wls_profile::weblogic::apply_patches` plan:

* [`targets`](#targets)

##### <a name="targets"></a>`targets`

Data type: `TargetSpec`

The WebLogic node(s) you want to patch

